/*----------------------------------------------------------------------------
 * Nazwa:   A_D_Konwersja.c	  
 * Funkcja: Plik procedur zwizanych z obsug przetwornika A/D
 *          programu demonstracyjnego	pytki	KAMAMI
 *			dla ukadu ZXCT1086 
 * Version: V1.00
 *----------------------------------------------------------------------------
 * Plik zawiera:
 * procedury obsugi przetwornika A/D
 *
 * Copyright (c) 2012 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
#include "A_D_Konwersja.h"
#include "stm32f10x_adc.h"
#include "Definicje_sprzet.h"

int16_t usrednione_napiecie_Vz;
uint16_t numer_pomiaru;
int8_t ofset_01V_pomiaru_Vz;

//inicjacja pomiarw przetwornika A/D
void A_D_Konwersja_Inicjacja(void)
{
ADC_InitTypeDef ADC_InitStructure;

	/* Enable ADC1 clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

	//jeden przetwornik pracujcy niezalenie
	ADC_InitStructure.ADC_Mode =ADC_Mode_Independent;
	//pomiar jednego kanau, wyczona opcja skanowania
    ADC_InitStructure.ADC_ScanConvMode =DISABLE;
	//wczony pomiar w trybie cigym
	ADC_InitStructure.ADC_ContinuousConvMode =ENABLE;
	//brak wyzwalania zewntrznego	  
	ADC_InitStructure.ADC_ExternalTrigConv =ADC_ExternalTrigConv_None;
	//dane wyrwnywane do prawej -12 znaczcych najmodszych bitw
	ADC_InitStructure.ADC_DataAlign =ADC_DataAlign_Right;
	//jeden kana
	ADC_InitStructure.ADC_NbrOfChannel =1;
	//inijacja przetwornika
	ADC_Init(ADC1, &ADC_InitStructure);
	//grupa regularna, wejcie 2, czas prkowania
	ADC_RegularChannelConfig(ADC1, KANAL_KONWERSJI_AD_VZ, 1, ADC_SampleTime_71Cycles5);

	//wczenie ADC1
	ADC_Cmd(ADC1, ENABLE);

	//reset rejestrw kalibracyjnych
	ADC_ResetCalibration(ADC1);
	//oczekiwanie na zakoczenie resetu
	while (ADC_GetResetCalibrationStatus(ADC1));

	//start kalibracji ADC1
	ADC_StartCalibration(ADC1);
	//oczekiwanie na zakoczenie kalibracji
	while (ADC_GetCalibrationStatus(ADC1));

	//start konwersji
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);

	usrednione_napiecie_Vz =0;
	numer_pomiaru =0xFFFF;
}

//pomiar napicia Vsense
float A_D_Konwersja_Pomiar_Vz(void)
{
uint16_t ADC1Val;
#define NAPIECIE_ODNIESIENIA	3.3
#define ROZDZIELCZOSC_AD_KONWERSJI	4095
float wartosc1_float; 


	ADC1Val =ADC_GetConversionValue(ADC1);
	wartosc1_float =NAPIECIE_ODNIESIENIA;
	wartosc1_float =wartosc1_float / ROZDZIELCZOSC_AD_KONWERSJI;
    wartosc1_float =wartosc1_float * ADC1Val;
    
	return wartosc1_float;
}

