/*
  ******************************************************************************
  * @file    main.c 
  * @author  ARIES
  * @version V1.00
  * @date    1-02-2012
  * @brief   gwna procedura programu demonstracyjnego	pytki	KAMAMI
  * dla ukadu ZXCT1086 
  ******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "stm32f10x_conf.h"
#include "GPIO_procedury.h"
#include "lcdlib.h"
#include "LCD_procedury.h"
#include "A_D_Konwersja.h"
#include <stdio.h>

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define GAIN_FIX_ZXCT1086	50
#define R_SENSE				0.02
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
	signed char contrast = 42;							// contrast value
	int Y_poz;
	float v_sense, i_current;
	char bufor[10];

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void NVIC_Configuration(void);
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_stm32f10x_xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_stm32f10x.c file
     */    
  	SystemInit();
//	SystemInit();
	NVIC_Configuration();
	  
  	//inicjacja linii portw I/O
  	GPIO_Inicjacja();
  	//inicjacja przetwornika A/D mierzcego napicie zasilania
  	A_D_Konwersja_Inicjacja();

  	//inicjacja SPI
//  	SPI_Configuration();
  	// Initialize LCD
  	InitLcdNokia();
	// Set contrast
	SetContrast(contrast);
	// Clear screen
	LCDClearScreen(0x0);

	//wywietlanie tekstu 
	Y_poz =LCD_Y_LINII -LCD_CHAR_Y_LINII -5;
	LCD_DisplayString(LCD_FONT_16_24, 0, Y_poz, "ZXCT1086");
	Y_poz =LCD_Y_LINII -(2*LCD_CHAR_Y_LINII) -5;
	LCD_DisplayString(LCD_FONT_16_24, 5, Y_poz, "I(A) =");

  /* Infinite loop */
  while (1)
  {
  	v_sense =A_D_Konwersja_Pomiar_Vz();
	i_current =v_sense / (R_SENSE * GAIN_FIX_ZXCT1086);
	//uwzgldnienie ofsetu pomiaru
	if ((i_current -0.100) <0) i_current =0;
	else i_current =i_current -0.100;
	snprintf(&bufor[0], 6, "%f2.3", i_current);
	Y_poz =LCD_Y_LINII -(3*LCD_CHAR_Y_LINII) -5; 
    LCD_DisplayString(LCD_FONT_16_24, 5, Y_poz, &bufor[0]);
  }
}

void NVIC_Configuration(void)
{

  	//Set the Vector Table base location at 0x08000000  
  	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
} 

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
