/*----------------------------------------------------------------------------
 * Nazwa:    LCD_procedury.c	  
 * Funkcja: Plik procedur zwizanych ze sterowaniem wywietlacza 
 *          LCD PT0282432T (z KAMAMI)
 *          testera dla radio-modemu ARM73 
 *          z mikrokontrolerem CORTEX STM32
 * Version: V1.00
 *----------------------------------------------------------------------------
 * Plik zawiera:
 * procedury inicjacji poziomw na liniach sterujcych wywietlaczem
 *
 * Copyright (c) 2009 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
//#include "platform_config.h"
#include "LCD_procedury.h"
#include "lcdlib.h"
#include "fonts1.h"
#include <string.h>

extern void LCDSetPixel(int x, int y, unsigned int color);

//wywietlanie znaku ASCII 
char LCD_DisplayChar(char typ_fontu, int Line, int Column, char Ascii)
{

	if (Ascii <32) return 0;
	Ascii -= 32;

	if (typ_fontu ==LCD_FONT_16_24)
	{
		LCD_DrawChar(Line, Column, &ASCII_Table[Ascii * 24]);
		return LCD_CHAR_X_PIKSELI;
	}

	if (typ_fontu ==LCD_FONT_6_8)
	{
		LCD_DrawCharM(Line, Column, &ASCII_Table_M[Ascii * 6]);
		return LCD_CHAR_M_X_PIKSELI;
	}

	if (typ_fontu ==LCD_FONT_URW_GOTHIC_ZMIENNY)
	{
		return 0;
	}

	return 0;
}


//----------------------------------------------------------------
//wykrelanie znaku ASCII 6x8
void LCD_DrawCharM(int Xpos, int Ypos, const char *c)
{
	char maska =0x80;
	int index = 0, i = 0;
	int Xaddress = 0;
	
	Xaddress = Xpos;

	
	for(index = 0; index < 8; index++)
	{
		for(i = 0; i < 6; i++)
     	{
			if ((c[i] &maska) ==0x00) LCDSetPixel(Xpos, Ypos, 0x0);
			else LCDSetPixel(Xpos, Ypos, 0xFFF);	
			Xpos++;
		}
		Ypos++;
		Xpos =Xaddress;
		maska =maska >>1;
	}
}
//-----------------------------------------------------------------
//wykrelanie znaku ASCII 16x24
void LCD_DrawChar(int Xpos, int Ypos, const int *c)
{

	int index = 0, i = 0;
	int Xaddress = 0;
	
	Xaddress = Xpos;


	for(index = 23; index >=0; index--)
	{
		for(i = 0; i < 16; i++)
     	{
       		if((c[index] & (1 << i)) == 0x00)
       		{
         		LCDSetPixel(Xpos, Ypos, 0x0);
       		}
       		else
       		{
        		LCDSetPixel(Xpos, Ypos, 0xFFF);
       		}  
			Xpos++;
	    }
		Ypos++;
		Xpos =Xaddress;
	}
}

//-------------------------------------------------------------------
//wywietlanie tekstu 
void LCD_DisplayString(char typ_fontu, char Xpos, int Ypos, char *ptr)
{
int cntr_poz_x, cntr_poz_y, Xpos_bak;

	cntr_poz_x =Xpos;
	Xpos_bak =Xpos;
	cntr_poz_y =Ypos;

	if (typ_fontu ==LCD_FONT_16_24)
	{	
		while (*ptr != 0)
		{
			if (((cntr_poz_x+LCD_CHAR_X_PIKSELI) >=LCD_X_PIKSELI) || //koniec linii LCD 
			     (*ptr =='\r'))	//lub znak \r
			{
				Ypos =Ypos +LCD_CHAR_Y_LINII;
				cntr_poz_y =Ypos;
				Xpos =Xpos_bak;
			}
			if ((cntr_poz_y +LCD_CHAR_Y_LINII) >=LCD_Y_LINII) return;//brak miejsca na LCD
			if (*ptr =='\r')
			{
			    ptr++;
				continue;
			}
			LCD_DisplayChar(LCD_FONT_16_24, Xpos, Ypos, *ptr);
			Xpos =Xpos +LCD_CHAR_X_PIKSELI;
			cntr_poz_x =Xpos;
			ptr++;
		}	 
	}
	if (typ_fontu ==LCD_FONT_6_8)
	{
		while (*ptr != 0)
		{
			if (((cntr_poz_x+LCD_CHAR_M_X_PIKSELI) >=LCD_X_PIKSELI) || //koniec linii LCD 
				(*ptr =='\r'))	//lub znak \n
			{
				Ypos =Ypos +LCD_CHAR_M_Y_LINII+2;
				cntr_poz_y =Ypos;
				Xpos =Xpos_bak;
			}
			if ((cntr_poz_y +LCD_CHAR_M_Y_LINII) >=LCD_Y_LINII) return;//brak miejsca na LCD
			if (*ptr =='\r')
			{
			    ptr++;
				continue;
			}
			LCD_DisplayChar(LCD_FONT_6_8, Xpos, Ypos, *ptr);
			Xpos =Xpos +LCD_CHAR_M_X_PIKSELI;
			cntr_poz_x =Xpos;
			ptr++;
		}
	}
	if (typ_fontu ==LCD_FONT_URW_GOTHIC_ZMIENNY)
	{	 /*
		szerokosc_znaku =0;
		while (*ptr != 0)
		{
			if (((cntr_poz_x+szerokosc_znaku) >=zmienna_LCD_X_PIKSELI) || //koniec linii LCD 
			     (*ptr =='\r'))	//lub znak \r
			{
				Ypos =Ypos +LCD_CHAR_URW_Gothic_15px_Y_LINII;
				cntr_poz_y =Ypos;
				Xpos =Xpos_bak;
			}
			if ((cntr_poz_y +LCD_CHAR_URW_Gothic_15px_Y_LINII) >=zmienna_LCD_Y_LINII) return;//brak miejsca na LCD
			if (*ptr =='\r')
			{
			    ptr++;
				continue;
			}
			szerokosc_znaku =LCD_DisplayChar(LCD_FONT_URW_GOTHIC_ZMIENNY, Xpos, Ypos, *ptr);
			Xpos =Xpos +szerokosc_znaku;
			cntr_poz_x =Xpos;
			ptr++;
		}	*/
	}
}
