/*----------------------------------------------------------------------------
 * Nazwa:   LCD_procedury.h	  
 * Funkcja: Plik nagwkowy procedur zwizanych ze sterowaniem wywietlacza 
 *          LCD PT0282432T (z KAMAMI)
 *          testera dla radio-modemu ARM73 
 *          zwizanych z liniami portw	I/O
 * 	
 * Version: V1.00
 *----------------------------------------------------------------------------
 * Plik zawiera:
 * deklaracje procedur inicjacji poziomw na liniach sterujcych wywietlaczem
 *
 * Copyright (c) 2009 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __LCD_PROCEDURY_H
#define __LCD_PROCEDURY_H


//funkcje i zmienne zewntrzne
//	main.c

void LCD_DrawCharM(int Xpos, int Ypos, const char *c);
void LCD_DrawChar(int Xpos, int Ypos, const int *c);
char LCD_DisplayChar(char typ_fontu, int Line, int Column, char Ascii);
void LCD_DisplayString(char typ_fontu, char Xpos, int Ypos, char *ptr);

//identyfikatory wymiarw wywietlacza
#define LCD_X_PIKSELI	132
#define LCD_Y_LINII		132
//identyfikator wywietlanych fontw
#define LCD_FONT_16_24				0
#define LCD_FONT_6_8				1
#define LCD_FONT_URW_GOTHIC_ZMIENNY	2
//identyfikatory wymiarw znaku ASCII 16x24
#define LCD_CHAR_X_PIKSELI	16
#define LCD_CHAR_Y_LINII	24
//identyfikatory wymiarw znaku ASCII 6x8
#define LCD_CHAR_M_X_PIKSELI	6
#define LCD_CHAR_M_Y_LINII		8	 
#endif

